//
//
//

#include <stdio.h>
#include <windows.h>
#include <stdlib.h>
#include "True_Bmp.h"
#include "True_Pcx.h"

#define	PCX_PLANES	4

typedef struct {
    unsigned char   Id;
    unsigned char   Version;
    unsigned char   Format;
    unsigned char   BitsPixelPlane;
    unsigned short  Xmin;
    unsigned short  Ymin;
    unsigned short  Xmax;
    unsigned short  Ymax;
    unsigned short  Hdpi;
    unsigned short  Vdpi;
    unsigned char   EgaPalette[48];
    unsigned char   Reserved;
    unsigned char   NumberOfPlanes;
    unsigned short  BytesLinePlane;
    unsigned short  PaletteInfo;
    unsigned short  HScreenSize;
    unsigned short  VScreenSize;
    unsigned char   Filler[54];
} PCXHEADER;

short Pcx_DecodeScanLine(unsigned char *DecodedBuffer, int BufferSize, FILE *FpPcx)
{
	static char rcount = 0;
    static char rvalue = 0;
	short total;
    int index;
    char byte;

	total = 0;
    index = 0;
	//
    do {
        for(total += rcount; rcount && index < BufferSize; rcount -- , index ++)
            DecodedBuffer[index] = rvalue;
		// decoding scanline

        if(rcount) {
            total -= rcount;
            return(total);
        } // return count of decoded pixels

		fread(&byte, 1, 1, FpPcx);
        if((byte & 0xC0) == 0xC0) {
            rcount = byte & 0x3F;
            fread(&rvalue, 1, 1, FpPcx);
        } else {
            rcount = 1;
            rvalue = byte;
        }
		// get and decode next pixel
    } while(index < BufferSize);

	// return count of decoded pixels
    return(total);
}

BMP	*Load_True_ColorPCX(char *Cesta)
{
	PCXHEADER PCXHead;
	int scanlen;
	FILE *PCXfp;
	char *plane;
	int y, x;
	BMP *tmp;

	if((PCXfp = fopen(Cesta, "rb")) == NULL)
		return NULL;
	// opens file

	fread(&PCXHead, sizeof(PCXHead), 1, PCXfp);
	// reads header

	if(PCXHead.NumberOfPlanes != 3 || PCXHead.BitsPixelPlane != 8) {
		fclose(PCXfp);
		return NULL;
	}
	// truecolor pcx-check

	if((tmp = (BMP*) malloc(sizeof(BMP))) == NULL)
		return NULL;
	// alloc raster

	tmp->width = PCXHead.Xmax - PCXHead.Xmin + 1;
	tmp->height = PCXHead.Ymax - PCXHead.Ymin + 1;
	// image size

	if((tmp->bytes = (unsigned __int32*) malloc(4 * tmp->width * tmp->height)) == NULL) {
		fclose(PCXfp);
		return NULL;
	}
	// alloc mem for bitmap

	scanlen = PCXHead.NumberOfPlanes * PCXHead.BytesLinePlane;
	// compute length of scanline

	if((plane = (char*) malloc(scanlen)) == NULL) {
		fclose(PCXfp);
		return NULL;
	}
	// alloc mem for plane

	for(y = 0; y < tmp->height; y ++) {
		if(Pcx_DecodeScanLine(plane, scanlen, PCXfp) != scanlen) {
			fclose(PCXfp);
			free(plane);
			//
			return NULL;
		}
		for(x = 0; x < tmp->width; x ++) {
			tmp->bytes[x + tmp->width * y] = RGB(plane[x],
				plane[x + PCXHead.BytesLinePlane], plane[x + 2 * PCXHead.BytesLinePlane]);
		}
	}
	// reading pcx

	fclose(PCXfp);
	free(plane);
	// free memory, close file

	return tmp;
}
